## openarena 0.7.0

=== Makefile ===
--- 
+++ 
@@ -113,7 +113,7 @@
 endif
 
 ifndef USE_CODEC_VORBIS
-USE_CODEC_VORBIS=0
+USE_CODEC_VORBIS=1
 endif
 
 ifndef USE_LOCAL_HEADERS
@@ -428,8 +428,8 @@
 
 ifeq ($(PLATFORM),mingw32)
 
-  CC=gcc
-  WINDRES=windres
+  CC=/home/justme/mingw32/bin/mingw32-gcc-3.4.5
+  WINDRES=/home/justme/mingw32/bin/mingw32-windres
 
   ARCH=x86
 
@@ -453,7 +453,7 @@
   GL_CFLAGS =
   MINGW_CFLAGS = -DDONT_TYPEDEF_INT32
 
-  OPTIMIZE = -O3 -march=i586 -fomit-frame-pointer -ffast-math -falign-loops=2 \
+  OPTIMIZE = -O2 -march=i586 -fomit-frame-pointer -ffast-math -falign-loops=2 \
     -funroll-loops -falign-jumps=2 -falign-functions=2 -fstrength-reduce
 
   HAVE_VM_COMPILED = true
@@ -488,7 +488,3 @@
   endif
 
   BUILD_SERVER = 0
-  BUILD_CLIENT_SMP = 0
-
-else # ifeq mingw32
-
