## openarena 0.8.1

=== debian/changelog ===
openarena (0.8.1-6) unstable; urgency=low

  * Convert source package to format 3.0 quilt
    * Drop build dependency on quilt
    * Remove quilt calls from debian/rules
    * Drop build dependency on sharutils, because we now can ship (binary) PNG
      icons in debian 3.0 source packages
  * Import a patch from Simon McVittie (see #546184 for details) to fix building
    openarena on amd64 processors with a 32bit userland. Thanks to Simon
    McVittie! (Closes: #546184)
  * Allow parallel builds for SMP machines to speed up building openarena
  * Update Vcs-* fields as this package now lives in Git

 -- Bruno "Fuddl" Kleinert <fuddl@debian.org>  Thu, 19 Nov 2009 17:37:45 +0100

openarena (0.8.1-5) unstable; urgency=low

  [ Gonéri Le Bouder ]
  * Segfault when deleting non-existent ban address 0, thanks Guillaume
    Delacour (Closes: #532212)
  * Standards version: 3.8.3
   - README.source to explain how the quilt patch system works 
  
  [ Paul Wise ]
  * Drop the dh_desktop call

 -- Gonéri Le Bouder <goneri@rulezlan.org>  Fri, 21 Aug 2009 20:16:35 +0200

openarena (0.8.1-4) unstable; urgency=low

  [ Gonéri Le Bouder ]
  * fix FTBFS on kFreeBSD, thanks Cyril Brulebois (#413617)
  * Standard version 3.8.1, no change

  [ Paul Wise ]
  * Makes the desktop file valid according to desktop-file-validate

 -- Gonéri Le Bouder <goneri@rulezlan.org>  Sun, 19 Apr 2009 19:49:34 +0200

openarena (0.8.1-3) unstable; urgency=low

  * Turn on BUILD_CLIENT_SMP (Closes: #517894) 

 -- Gonéri Le Bouder <goneri@rulezlan.org>  Mon, 02 Mar 2009 21:47:05 +0100

openarena (0.8.1-2) unstable; urgency=low

  * Upload to unstable
  * Add myself in uploaders:

 -- Gonéri Le Bouder <goneri@rulezlan.org>  Sat, 14 Feb 2009 15:42:55 +0100

openarena (0.8.1-1) experimental; urgency=low

  * New upstream release
  * Remove dfsg from version string because upstream no longer distributes
    non-free code
  * Update my email address where necessary
  * Install documentation files in the binary packages openarena and
    openarena-server 
  * Switch to quilt as patch management system
    * Use quilt in debian/rules
    * Import existing patches to quilt
    * Drop dpatch and add quilt als build dependency
  * Refresh/edit 10_remove_upstream_build_flags.diff: We want to keep
    distribution-specific build flags in our rules file
  * Add 20_dont_build_shipped_jpeg.diff to build against system jpeg library
    (Closes: #495966)
  * Add 30_link_against_local_libspeex.diff to build against system speex and
    speexdsp libraries

 -- Bruno "Fuddl" Kleinert <fuddl@debian.org>  Sun, 23 Nov 2008 23:19:22 +0100

openarena (0.7.7+dfsg1-1) unstable; urgency=low

  * Remove non-free code/tools/lcc (Closes: #496346)
    + Remove hunk from patch 10_fix_build_and_binary_on_alpha
    + debian/rules: Add BUILD_GAME_QVM=0 to $(MAKE) call
      (thanks to Peter De Wachter)
  * Remove code/libs containing binary libraries for Mac OS X and Win32
  * debian/copyright: Explain which parts of upstream's sources were removed
  * debian/rules: replace ${source:Upstream-Version} by 0.7.7
    because the variable also contains the `+dfsg1' part
  * Add -fsigned-char to compiler options (Closes: #487970)
    (thanks to Peter De Wachter)
  * Add myself to Uploaders
  * debian/control: Remove article from beginning of short description,
    don't start short description with a capital letter
  * debian/openarena.6: Escape minus signs
    + fixes lintian warnings: hyphen-used-as-minus-sign

 -- Ansgar Burchardt <ansgar@43-1.org>  Fri, 05 Sep 2008 21:14:51 +0200

openarena (0.7.7-1) unstable; urgency=low

  * New upstream release (Closes: #485675)
  * Add 10_remove_upstream_build_flags.dpatch to remove hard-wired build flags
  * Get rid of wrapper scripts
    * Update manpages to reflect the lack of --help, which was formerly
      interpreted by the wrapper scripts
    * Update debian/rules to install binaries in /usr/games instead of
      /usr/lib/games/openarena

 -- Bruno "Fuddl" Kleinert <fuddl@tauware.de>  Tue, 24 Jun 2008 12:03:06 +0200

openarena (0.7.6-1) unstable; urgency=low

  [ Bruno "Fuddl" Kleinert ]
  * New upstream release
  * Freshen 10_fix_build_and_binary_on_alpha.dpatch to apply to latest
    upstream sources
  * Remove 10-fix_menudef.h_includes.dpatch which pulled in a missing header
    file. The header is now included in the upstream tarball.
  * Remove debian/watch, because upstream places its new releases too often to
    different download locations
  * Updated debian/copyright to reflect the download location
  * Expand copyright years in debian/copyright

 -- Bruno "Fuddl" Kleinert <fuddl@tauware.de>  Thu, 24 Apr 2008 14:33:54 +0200

openarena (0.7.0-3) unstable; urgency=low

  [ Bruno "Fuddl" Kleinert ]
  * Rename XS-Vcs-fields to Vcs-fields in the control file
  * Remove Homepage URLs from package descriptions
  * Update my email address where necessary
  * Update to standards version 3.7.3.0. No changes
  * Add comment to 10-fix_menudef.h_includes.dpatch. Found by lintian
  * Install PNG desktop icon to correct location
  * Build-Depend on libcurl4-gnutls-dev instead of deprecated libcurl3-dev
  * Build-depend on debhelper >= 5.0.51. Found by lintian
    * We need dh_icons of version >= 5.0.51

  [ Ansgar Burchardt ]
  * Remove deprecated Encoding key from .desktop file

 -- Bruno "Fuddl" Kleinert <fuddl@tauware.de>  Sat, 22 Mar 2008 14:23:16 +0100

openarena (0.7.0-2) unstable; urgency=low

  * Fix inadvertent installation of files below usr/share/doc/openarena-server
    by the openarena (client) package. (Closes: #440173)

  [ Barry deFreese ]
  * Add watch file

  [ Jon Dowland ]
  * add Homepage: control field to source stanza

 -- Jon Dowland <jon@alcopop.org>  Mon, 03 Dec 2007 17:45:55 +0000

openarena (0.7.0-1) unstable; urgency=low

  [ Bruno "Fuddl" Kleinert ]
  * New upstream release (Closes: #432477)
  * Build-depend on libcurl3-dev (Closes: #430739)

