=== debian/control ===
Source: openarena
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Bruno "Fuddl" Kleinert <fuddl@debian.org>, Ansgar Burchardt <ansgar@43-1.org>, Gonéri Le Bouder <goneri@rulezlan.org>
Build-Depends: debhelper (>= 5.0.51), libsdl1.2-dev, libopenal-dev, imagemagick, libcurl4-gnutls-dev, libvorbis-dev, libjpeg62-dev, libspeexdsp-dev
Standards-Version: 3.8.3
Vcs-Git: git://git.debian.org/git/pkg-games/openarena.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/openarena.git;a=summary
Homepage: http://openarena.ws/

Package: openarena
Architecture: any
Depends: ${shlibs:Depends}, openarena-data (>= 0.7.7)
Description: fast-paced 3D first-person shooter
 OpenArena is an open-source content package for ioQuake3 licensed under the
 GPL, effectively creating a free stand-alone game. Though OpenArena is a free
 replacement for id Software Inc.'s Quake 3 Arena, it is NOT compatible with
 the proprietary game!
 .
 OpenArena might be considered unsuitable for children.
 .
 This package installs the OpenArena client.

Package: openarena-server
Architecture: any
Depends: ${shlibs:Depends}, openarena-data (>= 0.7.7)
Description: game server for the game OpenArena
 OpenArena is an open-source content package for ioQuake3 licensed under the
 GPL, effectively creating a free stand-alone game. Though OpenArena is a free
 replacement for id Software Inc.'s Quake 3 Arena, it is NOT compatible with
 the proprietary game!
 .
 This package installs the OpenArena dedicated server.
