=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

Q3ARCH             := $(shell sh $(CURDIR)/debian/q3arch.sh arch     HOST)
Q3PLATFORM         := $(shell sh $(CURDIR)/debian/q3arch.sh platform HOST)
Q3COMPILE_ARCH     := $(shell sh $(CURDIR)/debian/q3arch.sh arch     BUILD)
Q3COMPILE_PLATFORM := $(shell sh $(CURDIR)/debian/q3arch.sh platform BUILD)

CFLAGS += -fsigned-char

build: build-stamp
build-stamp:
	dh_testdir
	$(MAKE) USE_CURL=1 \
			USE_CURL_DLOPEN=0 \
			USE_OPENAL=1 \
			USE_OPENAL_DLOPEN=0 \
			USE_VOIP=1 \
			USE_INTERNAL_SPEEX=0 \
			BUILD_CLIENT_SMP=1 \
			USE_LOCAL_HEADERS=0 \
			DEFAULT_BASEDIR=/usr/share/games/openarena \
			ARCH=$(Q3ARCH) \
			PLATFORM=$(Q3PLATFORM) \
			COMPILE_ARCH=$(Q3COMPILE_ARCH) \
			COMPILE_PLATFORM=$(Q3COMPILE_PLATFORM)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) distclean
	rm -f debian/openarena32.xpm
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	mkdir -p debian/tmp
	cp build/release-$(Q3PLATFORM)-$(Q3ARCH)/openarena.$(Q3ARCH) debian/tmp/openarena
	cp build/release-$(Q3PLATFORM)-$(Q3ARCH)/oa_ded.$(Q3ARCH) debian/tmp/openarena-server
	convert -scale 32x32 debian/openarena128.png debian/openarena32.xpm
	dh_install
	dh_installdirs


binary-indep: build install
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_link
	dh_installmenu
	dh_installchangelogs
	dh_installman -popenarena debian/openarena.6
	dh_installman -popenarena-server debian/openarena-server.6
	dh_icons -popenarena
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
